from pybricks.hubs import ThisHub
from pybricks.pupdevices import Motor
from pybricks.parameters import Port, Stop
from pybricks.tools import wait, StopWatch


hub = ThisHub()
motorA = Motor(Port.A)
motorB = Motor(Port.B)
motorC = Motor(Port.C)
motorD = Motor(Port.D)
motorA.reset_angle(0)
motorB.reset_angle(0)
motorC.reset_angle(0)
motorD.reset_angle(0)
print("_file_begin_", "log.csv")
print(
    "Time Stamp (ms); Raise time(ms); Battery voltage (mV); Max Current (mA); Avg current raising (mA)"
)
watch = StopWatch()
watch.reset()

try:
    while True:
        maxcurrent = 0
        avgcurrent = 0
        nbcurrent = 0
        validcurrent = 1
        raisetime = watch.time()
        motorA.dc(-50)
        motorB.dc(-50)
        motorC.dc(-50)
        motorD.dc(-50)
        while motorA.angle() > -200:
            # print(watch.time(),";", hub.battery.voltage(),";", hub.battery.current())
            wait(10)
        motorA.dc(-100)
        motorB.dc(-100)
        motorC.dc(-100)
        motorD.dc(-100)
        while (
            motorA.angle() > -600
            or motorB.angle() > -600
            or motorC.angle() > -700
            or motorD.angle() > -700
        ):
            if motorA.angle() < -600:
                motorA.stop()
                validcurrent = 0
            if motorB.angle() < -600:
                motorB.stop()
                validcurrent = 0
            if motorC.angle() < -700:
                motorC.stop()
                validcurrent = 0
            if motorD.angle() < -700:
                motorD.stop()
                validcurrent = 0

            # print(watch.time(),";", hub.battery.voltage(),";", hub.battery.current())
            curcurrent = hub.battery.current()
            avgcurrent += curcurrent * validcurrent
            nbcurrent += 1
            if curcurrent > maxcurrent:
                maxcurrent = curcurrent
        raisetime = watch.time() - raisetime
        motorA.stop()
        motorB.stop()
        motorC.stop()
        motorD.stop()
        for i in range(50):
            # print(watch.time(),";", hub.battery.voltage(),";", hub.battery.current())
            wait(10)

        motorA.run_target(1000, 0, Stop.BRAKE, False)
        motorB.run_target(1000, 0, Stop.BRAKE, False)
        motorC.run_target(1000, 0, Stop.BRAKE, False)
        motorD.run_target(1000, 0, Stop.BRAKE, False)
        while not (
            motorA.control.done()
            and motorB.control.done()
            and motorC.control.done()
            and motorD.control.done()
        ):
            # print(watch.time(),";", hub.battery.voltage(),";", hub.battery.current())
            wait(10)

        for i in range(50):
            # print(watch.time(),";", hub.battery.voltage(),";", hub.battery.current())
            wait(10)
        print(
            watch.time(),
            int(raisetime),
            hub.battery.voltage(),
            int(maxcurrent),
            int(avgcurrent / nbcurrent),
            sep=";"
        )
        if hub.battery.voltage() < 5400:
            break
finally:
    print("_file_end_")
